package aracloud;
import java.io.File;
import java.nio.file.Files;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.text.SimpleDateFormat;
import org.w3c.dom.*;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author marcelo
 */
public class ConfManager {

    private File totalData;
    private String folderPath;
    private Document doc;
    private DocumentBuilder docBuilder;
    private DocumentBuilderFactory docFactory;

    public ConfManager(String confFile, String folderPath){
        totalData = new File(confFile);
        this.folderPath = folderPath;

        if(totalData.exists()){
            updateDataFile();
        }
        else{
            createDataFile(totalData);
        }
    }

    public void updateDataFile(){
        try{
            Files.delete(totalData.toPath());
        }
        catch(Exception e){

        }
        createDataFile(totalData);
    }

    public void addFile(String path){
        try{
            doc = docBuilder.parse(totalData);
            doc.getDocumentElement().normalize();

            System.out.println("Root element :" + doc.getDocumentElement().getNodeName());

        }
        catch(Exception e){

        }
    }

    public void deleteFile(String path){
        try{
            doc = docBuilder.parse(totalData);

        }
        catch(Exception e){

        }
    }



    private void createDataFile(File newDataFile){
        try {

            docFactory = DocumentBuilderFactory.newInstance();
            docBuilder = docFactory.newDocumentBuilder();

		// root elements
            doc = docBuilder.newDocument();
            Element rootElement = doc.createElement("acfmFileInfo");
            doc.appendChild(rootElement);

            File newFileData = new File(folderPath);
            listFilesForFolder(newFileData, rootElement);


            // write the content into xml file
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            DOMSource source = new DOMSource(doc);
            StreamResult result = new StreamResult(newDataFile);

		// Output to console for testing
		// StreamResult result = new StreamResult(System.out);

            transformer.transform(source, result);

            System.out.println("File saved!");

	  } catch (ParserConfigurationException pce) {
		pce.printStackTrace();
	  } catch (TransformerException tfe) {
		tfe.printStackTrace();
	  }
	}

    private void listFilesForFolder(final File folder, Node node) {
        Element current;
        Attr attribute;

        for (final File fileEntry : folder.listFiles()) {

            if (fileEntry.isDirectory()) {
                current = doc.createElement("folder");
                attribute = doc.createAttribute("name");
                attribute.setValue(fileEntry.getName());
                current.setAttributeNode(attribute);


                listFilesForFolder(fileEntry, current);
            }
            else {
                current = doc.createElement("file");
                attribute = doc.createAttribute("name");
                attribute.setValue(fileEntry.getName());

                Element time = doc.createElement("modified");
                SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");

                time.appendChild(doc.createTextNode(sdf.format(fileEntry.lastModified())));
                current.appendChild(time);
                current.setAttributeNode(attribute);

            }
            ((Element) node).appendChild(current);
        }
    }
}
